using XLSX
using DelimitedFiles
using Gadfly
using Random
using DataFrames

slats_dim = XLSX.readdata("Dataset0.xlsx", "Slats", "A5:C146")
panels_dim = XLSX.readdata("Dataset0.xlsx", "Panels", "B4:C4")

#Test results
answers = zeros(Int64, 60, 7) #Results vector: nb of lines = 3*nb of tests

#Loop for Tests
nbsl = 5000 #nb of slats composing the generated sample
cc = 1 #cc counts the total number of tests
while nbsl < 100001
    tst = 1 #tst counts the tests until 3 (3 tests for each nb of slats)
    while tst <=3

        #Generation of a random set
        newset = zeros(Int64, nbsl,3)
        for i in 1:nbsl
            rrr = rand(slats_dim[:,1])
            newset[i,1] = i
            newset[i,2] = slats_dim[rrr,2]
            newset[i,3] = slats_dim[rrr,3]
        end

        #Determination of P
        ar = 0
        for i in 1:size(newset,1)
            ar = ar + (newset[i,2]*newset[i,3])
        end

        #Sets
        S = newset[:,1] #Slat associated number
        l = newset[:,2] #Lengths of the slats
        w = newset[:,3] #Widths of the slats
        L = panels_dim[1] #Length of panels to create
        W = panels_dim[2] #Width of panels to create
        P = Int64(floor(ar/(L*W))) #Maximum theoritical nb of panels that can be created
        Y = zeros(Int64, P)

        ##Initial Sol
        d1 = ceil(Int64, L/minimum(l))
        d2 = ceil(Int64, W/minimum(w))
        Msol = zeros(Int64, minimum([maximum(S),d1*d2]), 4, P) #determining the maximum length of the solution vector Msol

        CPan = zeros(Int64, W, L, P)
        Pan = Vector{Int64}()
        rest = Vector{Int64}()
        li = 1
        col = 1
        mea = 0
        hei = 0
        Scopy = copy(newset)
        max = maximum(Scopy[:,3])
        Sgroup = findall(Scopy[:,3] .== max)
        i = 1
        s = 1
        cnt = 0
        kk = 1
        R = 1
        waste = 0
        constantw = 0

        # Showing elapsed time
        t1 = time() # gets current time (before calculation)

        while i <= P
            while findfirst(CPan[:,:,i] .== 0) !== nothing
                if max == 0
                    break #stop the first part of the algorithm
                elseif size(Sgroup,1) == 0 || sum(l[Sgroup]) < L
                    for u in 1:size(Sgroup, 1)
                        push!(rest, Sgroup[u])
                    end
                    max = max - 1
                    Sgroup = findall(Scopy[:,3] .== max)
                else
                    while mea < L
                        if hei + max > W && col == 1 #"best fit width" --> Generate as less surplus as possible along the length of the panel
                            kk = W - hei
                            Sgroup = findall(Scopy[:,3] .== kk)
                            if size(Sgroup,1) == 0 || sum(l[Sgroup]) < L
                                kk = 1
                                nkk = 1
                                while nkk <= max
                                    Sgroup = findall(Scopy[:,3] .== kk)
                                    if size(Sgroup,1) > 0 && sum(l[Sgroup]) >= L
                                        nkk = max + 1
                                    else
                                        kk = kk + 1
                                        nkk = nkk + 1
                                    end
                                end
                            end
                            if kk + hei > W
                                constantw = constantw + ((kk+hei-W)*L)
                            end
                        end
                        if mea + maximum(l[Sgroup]) > L
                            #best fit (length) --> Generate as less surplus as possible along the width of the panel
                            best_mea = mea + maximum(l[Sgroup])
                            best_fit = Sgroup[findfirst(l[Sgroup] .== maximum(l[Sgroup]))]
                            for zz in 1:size(Sgroup,1)
                                mea2 = mea + l[Sgroup[zz]]
                                if mea2 < best_mea && mea2 >= L
                                    best_mea = mea2
                                    best_fit = Sgroup[zz]
                                end
                            end
                            R = best_fit
                            waste = (best_mea - L)*w[R] #Strip associated surplus
                        else
                            R = Sgroup[findfirst(l[Sgroup] .== maximum(l[Sgroup]))]
                        end
                        for y in li:minimum([w[R]+li-1, W])
                            for z in col:minimum([l[R]+col-1, L])
                                CPan[y,z,i] = R
                            end
                        end
                        #Write and store the solution
                        Msol[s,1,i] = R
                        Msol[s,2,i] = li
                        Msol[s,3,i] = col
                        Msol[s,4,i] = waste
                        s = s + 1
                        col = col + l[R]
                        waste = 0
                        for tt in 1:3
                            Scopy[R,tt] = 0
                        end
                        if hei + max > W && col > 1 && col <= L
                            Sgroup = findall(Scopy[:,3] .== kk)
                        else
                            Sgroup = findall(Scopy[:,3] .== max)
                        end
                        mea = mea + l[R]
                        cnt = cnt + 1
                    end
                    li = li + w[R]
                    col = 1
                    mea = 0
                    hei = hei + w[R]
                end
            end
            if findfirst(CPan[:,:,i] .== 0) == nothing
                Y[i] = 1
            end
            #Next panel
            i = i + 1
            li = 1
            s = 1
            hei = 0
        end

        Solution = size(findall(Y .== 1), 1) #Number of panels created

        #Adding Slats "used for unfinished" panel to the Rest list
        if Solution < P
            for i in 1:W
                for j in 1:L
                    a = CPan[i,j,Solution+1]
                    if a !== 0 && findfirst(rest .== a) == nothing
                        push!(rest, a)
                    end
                    CPan[i,j,Solution+1] = 0
                end
            end
            #Modifying the soltuion vector
            for i in 1:minimum([maximum(S),d1*d2])
                Msol[i,1,Solution+1] = 0
                Msol[i,2,Solution+1] = 0
                Msol[i,3,Solution+1] = 0
                Msol[i,4,Solution+1] = 0
            end
        elseif Solution == P #Adding the rest of the slats in rest
            for i in 1:size(Scopy,1)
                a = Scopy[i,1]
                if a !== 0
                    push!(rest, a)
                    Scopy[i,1] = 0
                end
            end
        end
        #Add dimensions information to Rest
        s = size(rest,1)
        newrest = zeros(Int64, s, 3)
        for i in 1:s
            a = rest[i]
            newrest[i,1] = a
            newrest[i,2] = l[a]
            newrest[i,3] = w[a]
        end

        #total surplus over the width of the panels
        total_waste2 = sum(Msol[:,4,:])

        ##Local Search
        ww = Msol[:,4,:]

        #2nd part of the algorithm
        max2 = maximum(ww)
        while max2 > 0
            aaa = findall(Msol[:,4,:] .== max2)
            if size(aaa,1) > 0
                for f in 1:size(aaa,1)
                    aa = aaa[f]
                    vv = findall(Msol[:,2,aa[2]] .== Msol[aa[1],2,aa[2]])
                    sused = Vector{Int64}()
                    lused = 0
                    for i in 1:size(vv,1)
                        push!(sused, Msol[vv[i],1,aa[2]])
                        lused = lused + l[Msol[vv[i],1,aa[2]]]
                    end
                    sused = newset[sused,:]
                    lused
                    sample = newrest[findall(newrest[:,3] .== w[Msol[aa[1],1,aa[2]]]),:]
                    if size(sample,1) !== 0 && minimum(sample[:,2]) < maximum(sused[:,2])
                        candiin = sample[findfirst(sample[:,2] .== minimum(sample[:,2])),1]
                        candiout = sused[findfirst(sused[:,2] .== maximum(sused[:,2])),1]
                        sused = sused[Not(findfirst(sused[:,1] .== candiout)),:]
                        if sum(sused[:,2]) + l[candiin] >= L
                            ab = 1
                            for i in 1:size(vv,1)-1
                                for y in Msol[aa[1],2,aa[2]]:minimum([w[sused[i,1]]+Msol[aa[1],2,aa[2]]-1, W])
                                    for z in ab:minimum([l[sused[i,1]]+ab-1, L])
                                        CPan[y,z,aa[2]] = sused[i,1]
                                    end
                                end
                                Msol[vv[i],1,aa[2]] = sused[i,1]
                                Msol[vv[i],3,aa[2]] = ab
                                ab = ab + l[sused[i,1]]
                            end
                            for y in Msol[aa[1],2,aa[2]]:minimum([w[candiin]+Msol[aa[1],2,aa[2]]-1, W])
                                for z in ab:minimum([l[candiin]+ab-1, L])
                                    CPan[y,z,aa[2]] = candiin
                                end
                            end
                            #Change candiout per candiin in solution vector
                            Msol[aa[1],1,aa[2]] = candiin
                            Msol[aa[1],3,aa[2]] = ab
                            Msol[aa[1],4,aa[2]] = (sum(sused[:,2]) + l[candiin] - L)*w[candiin]
                            repl = findfirst(newrest[:,1] .== candiin)
                            #Add candiout in Rest
                            newrest[repl,1] = candiout
                            newrest[repl,2] = l[candiout]
                            newrest[repl,3] = w[candiout]
                        end
                    end
                end
            end
            max2 = max2 - 1
        end

        t2 = time() # gets current time (after calculation)
        computtime = round(t2 - t1; digits = 3)

        #Solution vector
        Msol
        #Visual Layout of the different panels
        CPan
        #newrest --> All the slats that are not used and still available for further usage
        newrest
        #Total waste generated by the strips before 2nd part of the algorithm
        total_waste2
        #Total waste generated by the strips after 2nd part of the algorithm
        total_waste3 = sum(Msol[:,4,:])
        #Total waste along the length of the panels
        constantw
        #Total waste generated by the strips before 2nd part of the algorithm (in cm2)
        total_waste22 = total_waste2*25
        #Total waste generated by the strips after 2nd part of the algorithm (in cm2)
        total_waste23 = total_waste3*25
        #Total waste along the length of the panels (in cm2)
        constantw2 = constantw*25
        #Total waste before the 2nd part of the algorithm (in cm2)
        tot_waste_cm22 = total_waste22+constantw2
        #Total waste after the 2nd part of the algorithm (in cm2)
        tot_waste_cm23 = total_waste23+constantw2
        #Total panel surface created (in cm2)
        tot_panel_cm2 = L*W*Solution*25
        #Waste ratio without the second part of the algorithm
        waste_rate2 = round(tot_waste_cm22/(tot_waste_cm22+tot_panel_cm2), digits = 4)
        #Waste ratio WITH the second part of the algorithm
        waste_rate3 = round(tot_waste_cm23/(tot_waste_cm23+tot_panel_cm2), digits = 4)

        #Write answers in tests results vector
        answers[cc,1] = nbsl
        answers[cc,2] = Solution
        answers[cc,3] = round(computtime*1000)
        answers[cc,4] = constantw2
        answers[cc,5] = total_waste23
        answers[cc,6] = tot_waste_cm23
        answers[cc,7] = round(waste_rate3*10000)

        cc = cc + 1
        tst = tst + 1
    end
    nbsl = nbsl + 5000
end

Test_V = DataFrame(Nb_Slats = [], Solution = [], Computing_time = [], Width_waste = [], Strips_waste = [], Tot_waste = [], Waste_ratio = [])
for i = 1:size(answers,1)
    push!(Test_V, vcat(answers[i,1], answers[i,2], answers[i,3]/1000, answers[i,4], answers[i,5], answers[i,6], answers[i,7]/10000))
end
Test_V
XLSX.writetable("Heuristic_Tests_5000-100000.xlsx", collect(DataFrames.eachcol(Test_V)), DataFrames.names(Test_V))
 algorithm
        total_waste2
        #Total waste generated by the strips after 2nd part of the algorithm
        total_waste3 = sum(Msol[:,4,:])
        #Total waste along the length of the panels
        constantw
        #Total waste generated by the strips before 2nd part of the algorithm (in cm2)
        total_waste22 = total_waste2*25
        #Total waste generated by the strips after 2nd part of the algorithm (in cm2)
        total_waste23 = total_waste3*25
        #Total waste along the length of the panels (in cm2)
        constantw2 = constantw*25
        #Total waste before the 2nd part of the algorithm (in cm2)
        tot_waste_cm22 = total_waste22+constantw2
        #Total waste after the 2nd part of the algorithm (in cm2)
        tot_waste_cm23 = total_waste23+constantw2
        #Total panel surface created (in cm2)
        tot_panel_cm2 = L*W*Solution*25
        #Waste ratio without the second part of the algorithm
        waste_rate2 = round(tot_waste_cm22/(tot_waste_cm22+tot_panel_cm2), digits = 4)
        #Waste ratio WITH the second part of the algorithm
        waste_rate3 = round(tot_waste_cm23/(tot_waste_cm23+tot_panel_cm2), digits = 4)

        #Write answers in tests results vector
        answers[cc,1] = nbsl
        answers[cc,2] = Solution
        answers[cc,3] = round(computtime*1000)
        answers[cc,4] = constantw2
        answers[cc,5] = total_waste23
        answers[cc,6] = tot_waste_cm23
        a